clear all;
close all;

%% read training data
n_samples = 2429;
training_data = zeros(361, n_samples);
for i = 1: n_samples
    if i < 10
        input_path = ['./train/face/' 'face0000' num2str(i) '.pgm'];
    else if i < 100
        input_path = ['./train/face/' 'face000' num2str(i) '.pgm'];   
    else if i < 1000
        input_path = ['./train/face/' 'face00' num2str(i) '.pgm'];        
    else
        input_path = ['./train/face/' 'face0' num2str(i) '.pgm'];        
            end
        end
    end
    
    %one row after another row is stored in the vector
    input_image = imread(input_path);
    [length, width] = size(input_image);
    training_data(:,i) = input_image(:);
    
end

%% perfom ANLS

q = 20;
[p l] = size(training_data);
max_iterations = 200;
% initialize with nonnegative values
B = ones(p, q)*0.1;
G = ones(q, l)*0.1;
Y = training_data;

epsilon_diff = 1e-10;
epsilon = 1e-5;
old_diff = inf;
% due some iterations
for i = 1:max_iterations
    for j = 1:l
        G(:,j) = lsqnonneg(B,Y(:,j),G(:,j));
    end

    for j = 1:p
        B(j,:) = lsqnonneg(G',Y(j,:)', B(j,:));
    end
    i
    % check distance to trainig matrix
    diff = sum(sum((B*G - Y).^2)) / sum(sum(Y.^2));
    
    if(abs(diff-old_diff) < epsilon_diff)
      break;
    elseif (diff < epsilon)
      break;
    end
    old_diff = diff;
    % display all base vectors
    figure;
    for k = 1:q
        subplot(ceil(sqrt(q)),ceil(sqrt(q)),k), imshow(reshape(255-B(:,k),19,19),[]);
    end
    % 
    % pause
end

